import { Directive, HostBinding, Input } from '@angular/core';

enum CardType{
  VISA="visa",
  MASTERCARD="mastercard",
  AMERICAN_EXPRESS="american-express",
  UNKNOWN="unknown"
}

@Directive({
  selector: '[appCclogo]',
  standalone: true
})
export class CclogoDirective {

  @HostBinding('src')
  imageSource:string="";  //Binding SRC Tag with Directive

  @Input()
  cardNumber:string="";  //Card Number is an Input can come from Any of the component

  constructor() { }

  //This event will be called by Angular Framework only when ever input variable changes
  ngOnChanges(){

    this.imageSource='/assets/card-types/'+ this.getCardTypeFromNumber()+'.png';
    //'assets/card-types/visa.png
    //'assets/card-types/mastercard.png

  }

  getCardTypeFromNumber():CardType{
    if(this.cardNumber){
      if(this.cardNumber.startsWith('42')){
        return CardType.VISA
      }else if (this.cardNumber.startsWith('35')){
        return CardType.MASTERCARD
      }else if (this.cardNumber.startsWith('22')){
        return CardType.AMERICAN_EXPRESS
      }else{
        return CardType.UNKNOWN
      }

    }else{
      return CardType.UNKNOWN
    }

  }

}
