import { AfterContentChecked, AfterContentInit, AfterViewChecked, 
  AfterViewInit, Component, DoCheck, OnChanges, OnDestroy, OnInit, 
  SimpleChanges}
   from '@angular/core';

@Component({
  selector: 'app-lifecycle',
  standalone: true,
  imports: [],
  templateUrl: './lifecycle.component.html',
  styleUrl: './lifecycle.component.css'
})
export class LifecycleComponent  implements 
OnInit,OnChanges,DoCheck,AfterViewInit,
AfterViewChecked,AfterContentInit,AfterContentChecked,OnDestroy{

  order=1;

  constructor(){
    console.log("Constructor is Called !! and the Order of Execution ===> " , this.order);
    this.order++;
  }

  ngOnChanges(changes: SimpleChanges): void {
    console.log("ngOnChanges is Called !! and the Order of Execution ===> " , this.order);
    this.order++;
  }

  ngOnInit(): void {
    console.log("ngOnInit is called  !! and the Order of Execution ==> ",this.order);
    this.order++;
  }

  ngDoCheck(): void {
    console.log("ngDoCheck is called  !! and the Order of Execution ==> ",this.order);
    this.order++;
  }

  ngAfterContentInit(): void {
    console.log("ngAfterContentInit is called  !! and the Order of Execution ==> ",this.order);
    this.order++;
  }

  ngAfterViewInit(): void {
    console.log("ngAfterViewInit is called  !! and the Order of Execution ==> ",this.order);
    this.order++;
  }

  ngAfterContentChecked(): void {
    console.log("ngAfterContentChecked is called  !! and the Order of Execution ==> ",this.order);
    this.order++;
  }

  ngAfterViewChecked(): void {
    console.log("ngAfterViewChecked is called  !! and the Order of Execution ==> ",this.order);
    this.order++;
  }

  ngOnDestroy(): void {
    console.log("ngOnDestroy is called  !! and the Order of Execution ==> ",this.order);
    this.order++;
  }

}
